/*
**      Small-C Preprocessor Ver 1.1    26-Dec-87 cpp3.c
**      Nick Andrew & J.E. Hendrix
**
*/

#include        "cpp.h"

junk()
        {
        if (an(inbyte()))
                while (an(ch))
                        gch();
        else
                while (an(ch)==0) {
                        if (ch == 0)
                                break;
                        gch();
                }
        blanks();
}

illname()
        {
        error("illegal symbol");
        junk();
}

/*
**      get integer i of length len into
**      address addr (low byte first)
*/

getint(addr, len)
char    *addr;
int     len;
        {
        int i;

        i = *(addr + --len);

        while (len--)
                i = (i << 8) | *(addr + len) & 255;

        return (i);
}

/*
**      put integer i of length len into address addr
**      (low byte first)
*/

putint(i, addr, len)
char    *addr;
int     i, len;
        {

        while (len--)   {
                *addr++ = i;
                i = i >> 8;
        }
}

/*
**      test if next input string is legal symbol name
*/

symname(sname, ucase)
char    *sname;
int     ucase;
        {
        int     k;

        blanks();

        if (alpha(ch) == 0)
                return (0);

        k = 0;

        while (an(ch))  {
                        sname[k] = gch();

                if (k < NAMEMAX)
                        ++k;
        }

        sname[k] = 0;
        return 1;
}

/*
**      test if given character is alphabetic
*/

alpha(c)
char    c;
        {

    return (  ((c >= 'a') & (c <= 'z'))
            | ((c >= 'A') & (c <= 'Z'))
            | (c == '_'));
}

/*
**      test if given character is numeric
*/

numeric(c)
char    c;
        {

        return ((c >= '0') & (c <= '9'));
}

/*
**      test if given character is alphanumeric
*/

an(c)
char    c;
        {

        return ((alpha(c)) | (numeric(c)));
}

white()
        {

        if (*lptr == ' ')
                return (1);

        if (*lptr == 9)
                return (1);

        return (0);
}

gch()
        {

        if (xc = ch)
                bump(1);

        return (xc);
}

bump(n)
int     n;
        {

        if (n)
                lptr = lptr + n;
        else
                lptr = iline;

        if (ch = nch = *lptr)
                nch = *(lptr + 1);
}

kill()
        {

        *iline = 0;
        bump(0);
}

inbyte()
        {

        while (ch == 0) {
                return (0);
        }

        return (gch());
}

